;-----------------------------------------------------------
;Background Picture v.90
;by John Kempen
;
;The source for this file is kind of messy, and I don't have many comments.
;
;Some parts were originally from some of my other programs, so if the labels are wierd,
;thats why.
;
;Send any questions, comments, or bug reports to:
;saywhat97@hotmail.com
;-----------------------------------------------------------
#include "asm86.h"
#include "ti86asm.inc"
#include "ti86abs.inc"

freespace = _asm_exec_ram+1600		;after program
xlevelstable = freespace
morefree = _asm_exec_ram+8000
menurow = morefree+10
rowl = morefree+11
r = morefree+12
mr = morefree+16
symlocate = morefree+20
xlevelsnum = morefree+22
xtableloc = morefree+23
chrleft = morefree+25
drawingmenu = morefree+26
regmenu = morefree+27
curmenu = morefree+28
next = morefree+30

.org _asm_exec_ram
	nop
	jp start
	.dw $0000
	.dw name
start
	call $49DC	
	res 0,(iy+18)
	res 2,(iy+13)
Firstmenu
	ld hl,menu1
	ld (curmenu),hl
	call _clrScrn
	call Bydraw
	jp Selectlevs
startselvar
	ld hl,vartablemenu
	ld (curmenu),hl
	call _clrScrn
	call FindVariables
	call Bydraw
	jp Selectlevs
End
	ld a,0
	ld (_curRow),a
	call _clrScrn
	set 0,(iy+18)
	set 2,(iy+13)
	ld a,$3c
	out (0),a
	ld a,$20
	ld ($c011),a
	ret
selectedlevjp
	ld hl,(curmenu)
	ld de,7
	add hl,de
	call $4010
	jp (hl)
Menuback
	ld hl,(curmenu)
	ld de,5
	add hl,de
	call $4010
	jp (hl)
mEnd
	ld hl,(curmenu)
	inc hl
	inc hl
	inc hl
	call $4010
	jp (hl)
Selectlevs
	ld hl,(curmenu)
	ld a,(hl)
	ld c,a
	ld (regmenu),a
	inc hl
	ld a,(hl)
	ld (menuminrow),a
	inc hl
	ld a,(hl)
	ld (menumaxrow),a
	call drawmenustart
	ld a,(menuminrow)
	ld (r),a
	ld (rowl),a
	ld a,1
	ld (mr),a
	jp Selectlevdraw
selectlevloop
	call _getkey
	cp kF2
	jp z,Menuback
	cp kEnter
	jp z,endmenu
	cp kExit
	jp z,mEnd
	cp kUp
	jr z,Selectlevup
	cp kDown
	jr z,Selectlevdown
	jr selectlevloop
Selectlevup
	ld a,(mr)
	cp 1
	jr z,Selectlevdraw
	dec a
	ld (mr),a
	ld a,(menuminrow)
	ld b,a
	ld a,(r)
	cp b
	jr z,selectscrlup
	dec a
	ld (r),a
	jr Selectlevdraw
Selectlevdown
	ld a,(xlevelsnum)
	ld b,a
	ld a,(mr)
	cp b
	jr z,Selectlevdraw
	inc a
	ld (mr),a
	ld a,(menumaxrow)
	ld b,a
	ld a,(r)
	cp b
	jr z,selectscrldown
	inc a
	ld (r),a
	jr Selectlevdraw
selectscrldown
	ld a,(menumaxrow)
	dec a
	ld (rowl),a
	call menuscrolldown
	jr Selectlevdraw
selectscrlup
	ld a,(menuminrow)
	inc a
	ld (rowl),a
	call menuscrollup
	jr Selectlevdraw
Selectlevdraw
	call Putvarinfo
	jp selectlevloop
Putvarinfo
	call getselectedtext
	ld a,(drawingmenu)
	cp 1
	jr z,nobardraw
	ld a,(rowl)
	ld (_curRow),a
	ld a,0
	ld (_curCol),a
	ld b,21
drawlastselectedloop
	push bc
	call findundercur
	call _putmap
	ld a,(_curCol)
	inc a
	ld (_curCol),a
	pop bc
	djnz drawlastselectedloop
	ld a,(r)
	call Invbar
nobardraw
	ld a,(r)
	ld (rowl),a
	ret
selectlevloopend								; loads selected world into savelev for saved games
	ret
getselectedtext
	ld hl,PTZWRLD
	ld a,$20
	ld (hl),a
	ld de,PTZWRLD+1
	ld bc,20
	ldir
	ld a,(regmenu)
	cp 1
	jp z,Selectlevhlcalc2
	cp 2
	jp z,Selectlevhlcalc2
	ld a,(mr)
	ld hl,xlevelstable-9
	ld de,9
Selectlevhlcalc
	or a
	add hl,de
	dec a
	cp 0
	jr nz,Selectlevhlcalc
	ld de,PTZWRLD
	ld bc,9
	ldir
	ld hl,PTZWRLD-1
	rst 20h
	rst 10h
	jr c,notafile
	ret
notafile
	pop hl
	jp Selectlevup
Selectlevhlcalc2
	ld hl,(curmenu)
	ld de,7
	or a
	add hl,de
	ld a,(hl)
	inc hl
	ld (xlevelsnum),a
	ld a,(mr)
	ld de,4
	or a
	sbc hl,de
Selectlevhlcalc2loop
	or a
	add hl,de
	dec a
	cp 0
	jr nz,Selectlevhlcalc2loop
	call $4010
	ld de,PTZWRLD+1
	ld b,20
Selectlevhlcalcloopend
	ld a,(hl)
	ex de,hl
	cp 0
	ret z
	ld (hl),a
	ex de,hl
	inc de
	inc hl
	djnz Selectlevhlcalcloopend
	ret
menuscrollup
	ld a,1
	ld (drawingmenu),a
	ld a,(menuminrow)
	ld (menurow),a
	call Drawmenusloop
	ld a,(menuminrow)
	ld (r),a
	ld a,(menuminrow)	
	ld b,a
	ld a,(menumaxrow)
	sub b
	ld b,a
	inc b
	ld a,(mr)
	sub b
	ld (mr),a
	ret
menuscrolldown
	ld a,1
	ld (drawingmenu),a
	ld a,(menuminrow)
	ld (menurow),a
	ld (r),a
	ld b,a
	ld a,(menumaxrow)
	sub b
	ld b,a
	ld a,(mr)
	sub b
	ld (mr),a
	call Drawmenusloop
	ld a,(menumaxrow)
	ld (r),a
	ld a,(mr)
	dec a
	ld (mr),a
	ret
drawmenustart
	ld a,1
	ld (drawingmenu),a
	ld (mr),a
	ld a,(menuminrow)
	ld (menurow),a
	ld (r),a
Drawmenusloop
	call Putvarinfo
	ld a,(r)
	ld (_curRow),a
	ld a,0
	ld (_curCol),a
	ld b,21
drawspaceloop
	push bc
	ld a,$20
	call _putmap
	ld a,(_curCol)
	inc a
	ld (_curCol),a
	pop bc
	djnz drawspaceloop
	ld a,(r)
	ld (_curRow),a
	ld a,1
	ld (_curCol),a
	ld hl,PTZWRLD+1								; displays world name
	call _puts
	ld a,(r)
	inc a
	ld (r),a
	ld a,(mr)
	inc a
	ld (mr),a
	ld a,(menumaxrow)
	inc a
	ld c,a
	ld a,(xlevelsnum)
	inc a
	ld b,a
	ld a,(menurow)
	inc a
	ld (menurow),a
	cp b
	jr z,Drawmenusloopend
	cp c
	jr nz,Drawmenusloop
Drawmenusloopend
	ld a,0
	ld (drawingmenu),a
	ret
endmenu
	ld a,(regmenu)
	cp 0
	jp nz,endmenua
	ld hl,PTZWRLD
	ld de,Filename
	ld bc,9
	ldir
	jp selectedlevjp
endmenua
	ld hl,(curmenu)
	ld de,10
	add hl,de
	ld a,(mr)
	ld de,4
	or a
	sbc hl,de
menuendhlcalc2loop
	or a
	add hl,de
	dec a
	cp 0
	jr nz,menuendhlcalc2loop
	ld a,(regmenu)
	cp 2
	jr z,menuend2
menuend1
	call $4010
	jp (hl)
menuend2
	call $4010
	ld (curmenu),hl
	jp startselvar


	
FindVariables
	call _clrScrn
	ld hl,_textShadow
	ld de,xlevelstable
	ld a,(hl)
	ld (de),a
	ld de,xlevelstable
	ld bc,2295
	ldir
	call $47f3									; load RAM page 7
	ld a,$bf
	ld h,a
	ld a,$ff
	ld l,a
	ld (symlocate),hl
	ld a,0
	ld (xlevelsnum),a
Symsearch
	call $47f3									; load RAM page 7
	ld hl,(symlocate)
	ld a,(hl)
	cp $11
	jr z,Stringfound	
	cp $ff
	jp z,Findlevsdone
Symsearchnot
	call $47f3									; load RAM page 7
	ld hl,(symlocate)
	ld de,5
	or a
	sbc hl,de
	ld a,0
	ld d,a
	ld a,(hl)
	inc a
	ld e,a
	or a
	sbc hl,de
	ld (symlocate),hl
	jr Symsearch
Stringfound
	ld hl,(symlocate)
	ld de,4
	or a
	sbc hl,de
	ld a,(hl)
	cp 0
	jr nz,Symsearchnot
;	ld hl,(symlocate)
;	dec hl
;	ld a,(hl)
;	ld e,a
;	dec hl
;	ld a,(hl)
;	ld d,a
;	dec hl
;	ld a,(hl)
;	ex de,hl
itsPtzlev
	call $47f3
	ld a,(xlevelsnum)
	cp 255
	jr z,Findlevsdone
	inc a
	ld (xlevelsnum),a
	ld hl,xlevelstable-9
	ld de,9
itsPtzlev1									;world found, next few lines write name to table
	add hl,de
	dec a
	cp 0
	jr nz,itsPtzlev1
	ld (xtableloc),hl
	ld hl,(symlocate)
	ld de,5
	or a
	sbc hl,de
	ld (symlocate),hl
	ld a,(hl)
	ld hl,(xtableloc)
	ld (hl),a
	ld (chrleft),a
itsPtzlevloop
	ld a,(chrleft)
	cp 0
	jr z,itsPtzlevloopend
	ld hl,(symlocate)
	dec hl
	ld (symlocate),hl
	ld a,(hl)
	ld hl,(xtableloc)
	inc hl
	ld (hl),a
	ld (xtableloc),hl
	ld a,(chrleft)
	dec a
	ld (chrleft),a
	jr itsPtzlevloop
itsPtzlevloopend
	ld hl,(symlocate)
	dec hl
	ld (symlocate),hl
	jp Symsearch
Findlevsdone
	call $47e3
	ld a,(xlevelsnum)
	cp 0									; checks if worlds were found
	jp z,not_a_lev_fnd
	ret
not_a_lev_fnd								; no worlds found on calculator
	call _clrLCD
	ld a,0
	ld (_curRow),a
	ld (_curCol),a
	ld hl,nolevsfnd
	call _puts
	call _getkey
	pop hl
	jp End
findundercur
	ld a,(_curRow)
	ld b,a
	inc b
	ld de,21
	ld hl,-21
findunderloop
	add hl,de
	djnz findunderloop
	ld a,(_curCol)
	ld e,a
	ld d,0
	add hl,de
	ld de,$c0f9
	add hl,de
	ld a,(hl)
	cp 214
	ret nz
	ld a,$20
	ret
Bydraw
	ld a,7
	ld (_curRow),a
	ld a,0
	ld (_curCol),a
	ld hl,bytext
	call _puts
	ld a,7
	ld (_curRow),a
	ld a,16
	ld (_curCol),a
	ld hl,versionnum
	call _puts
	ld a,7
	call Invbar
Namedraw
	ld a,0
	ld (_curRow),a
	ld (_curCol),a
	ld hl,nametext
	call _puts
	ld a,0
	call Invbar
	ret
Invbar
	set 3,(iy+5)
	ld (_curRow),a
	ld a,0
	ld (_curCol),a
	ld b,21
drawselectedinvloop
	push bc
	call findundercur
	call _putmap
	ld a,(_curCol)
	inc a
	ld (_curCol),a
	pop bc
	djnz drawselectedinvloop
	res 3,(iy+5)
	ret
	ld a,0
uninstall
	res 2,(iy+$23) 
	jp End
Help
	ld hl,textfiledata
	ld de,$c068
	ld bc,13
	ldir
;	pop hl
	ld hl,variable-1
	rst 20h
	rst 10h
	jr c,noHelp
	set 2,(iy+$1F)
	call _clrLCD
	call Bydraw
	ld hl,variable-1
	rst 20h
	call $5730	;_exec_assembly
	jp Firstmenu
noHelp
	call _clrLCD
	call Bydraw
	ld a,1
	ld (_curRow),a
	ld (_curCol),a
	ld hl,nohelpviewer
	call _puts
	call _getkey
	jp Firstmenu


load_pic
	ld hl,PTZWRLD-1
	rst 20h
	rst 10h
	ld a,b
	ex de,hl
	inc hl
	inc hl
	call _SET_ABS_SRC_ADDR
	ld hl,1008
	ld a,0
	call _SET_MM_NUM_BYTES
	ld hl,$f700
	ld a,0
	call _SET_ABS_DEST_ADDR
	call _mm_ldir

   ld hl,$faf0
	ld (hl),a
    ld de,$FAF1
    ld bc,16
    ldir

installint
_user_int_ram EQU $d2fd                      ;Area where interrupt handler goes

;====================================================================================================
; Install IM 1 Interrupt Handler
;====================================================================================================
	di
 res 2,(iy+$23)                       ;turn user int off so it won't get called by
                                      ;accident before we're ready   
 ld hl,int_copy                       ;copy prog to user int buffer
 ld de,_user_int_ram+1                ;1 byte ahead of checksum
 ld bc,int_end-int_start              ;length of interrupt handler
 ldir                                 ;hl is the source, de is the destination,
                                      ;and bc is the length   
 ld a,(_user_int_ram+1)               ;set up checksum byte
 ld hl,_user_int_ram+($28*1)          ;load byte
 add a,(hl)                           ;add to total
 ld hl,_user_int_ram+($28*2)          ;load byte
 add a,(hl)                           ;add to total
 ld hl,_user_int_ram+($28*3)          ;load byte
 add a,(hl)                           ;add to total
 ld hl,_user_int_ram+($28*4)          ;load byte
 add a,(hl)                           ;add to total
 ld hl,_user_int_ram+($28*5)          ;load byte
 add a,(hl)                           ;add to total
 ld (_user_int_ram),a                 ;load checksum in its location

	set 2,(iy+$23) 
	ei
	jp End                                 ; Return to shell or TI-OS



menu1
.db 1
.db 1
.db 6
.dw End
.dw Firstmenu
.db 5
.dw loadtxt
.dw startselvar
.dw installtxt
.dw installint
.dw uninstalltxt
.dw uninstall
.dw Helptxt
.dw Help
.dw endtxt
.dw End
Helptxt
.db "Help",0
uninstalltxt
.db "Uninstall BG pic",0
installtxt
.db "Re-install grayscale",0
loadtxt
.db "Load File",0
endtxt
.db "Exit",0
menuminrow
.db 1
menumaxrow
.db 4
leva
.db 0
levhl
.db 0,0
checkbytenum
.db 0
nolevsfnd
.db "No files found",0
name
.db "Back Ground Pic v.90 by John Kempen",0
Filename
.db 8,"12345678",0
PTZWRLD
.db 8,"12345678901234567890",0
bytext
.db "By John Kempen",0
versionnum
.db "v.90",0
nametext
.db "Background Pic",0
textfiledata
maxrow
.db 6
minrow
.db 1
maxcol
.db 20
mincol
.db 0
.db 7,"BGPHelp",0
variable
.db 8,"HelpView",0
nohelpviewer
.db "HelpView not found",0
vartablemenu
.db 0
.db 1
.db 6
.dw End
.dw Firstmenu
.dw load_pic
Varmenutable
;from ti86.acz.org
;====================================================================================================
; IM 1 Interrupt Handler code
;====================================================================================================
int_copy:
        .org $D2FE                       ; Intruction Counter starts at $D2FE
int_start:; ------[ interrupt code goes here ]------------EndInterrupt:

	ld a,(time)
	inc a
	ld (time),a
	cp 3
	jr z,lower
	cp 1
	jr z,upper
	jr end

upper
	ld a,$3c
	out (0),a
	jr end
lower
	ld a,0
	ld (time),a
	ld a,$37
	out (0),a
 
end                                    

	ret

time
.db 0
int_end



.end



installint
_user_int_ram EQU $d2fd                      ;Area where interrupt handler goes
;from ti86.acz.org
;====================================================================================================
; Install IM 1 Interrupt Handler
;====================================================================================================
	di
 res 2,(iy+$23)                       ;turn user int off so it won't get called by
                  
                    ;accident before we're ready   
 ld hl,int_copy                       ;copy prog to user int buffer
 ld de,_user_int_ram+1                ;1 byte ahead of checksum
 ld bc,int_end-int_start              ;length of interrupt handler
 ldir                                 ;hl is the source, de is the destination,
                                      ;and bc is the length   
 ld a,(_user_int_ram+1)               ;set up checksum byte
 ld hl,_user_int_ram+($28*1)          ;load byte
 add a,(hl)                           ;add to total
 ld hl,_user_int_ram+($28*2)          ;load byte
 add a,(hl)                           ;add to total
 ld hl,_user_int_ram+($28*3)          ;load byte
 add a,(hl)                           ;add to total
 ld hl,_user_int_ram+($28*4)          ;load byte
 add a,(hl)                           ;add to total
 ld hl,_user_int_ram+($28*5)          ;load byte
 add a,(hl)                           ;add to total
 ld (_user_int_ram),a                 ;load checksum in its location

	ld a,0
   ld hl,$faf0
	ld (hl),a
    ld de,$FAF1
    ld bc,16
    ldir



	set 2,(iy+$23) 
	ei
 ret                                 ; Return to shell or TI-OS

